# OpalMixerEndPoint Class Reference

`#include <opalmixer.h>`

Inheritance diagram for OpalMixerEndPoint:

[legend]
Collaboration diagram for OpalMixerEndPoint:
[legend]

## Public Member Functions

Construction
| OpalMixerEndPoint (OpalManager &manager, const char *prefix)
| ~OpalMixerEndPoint ()
virtual void | ShutDown ()
Overrides from OpalEndPoint
virtual OpalMediaFormatList | GetMediaFormats () const
virtual PSafePtr< OpalConnection > | MakeConnection (OpalCall &call, const PString &party, void *userData=NULL, unsigned options=0, OpalConnection::StringOptions *stringOptions=NULL)
virtual bool | GetConferenceStates (OpalConferenceStates &states, const PString &name=PString::Empty()) const
virtual PBoolean | GarbageCollection ()
Operations
PSafePtr< OpalMixerConnection > | GetMixerConnectionWithLock (const PString &token, PSafetyMode mode=PSafeReadWrite)
virtual OpalMixerConnection * | CreateConnection (PSafePtr< OpalMixerNode > node, OpalCall &call, void *userData, unsigned options, OpalConnection::StringOptions *stringOptions)
virtual OpalMixerNodeInfo * | FindNodeInfo (const PString &name)
Member variable access
void | SetAdHocNodeInfo (const OpalMixerNodeInfo &info)
void | SetAdHocNodeInfo (OpalMixerNodeInfo *info)
OpalMixerNodeInfo * | GetAdHocNodeInfo ()
void | SetFactoryNodeInfo (const OpalMixerNodeInfo &info)
void | SetFactoryNodeInfo (OpalMixerNodeInfo *info)
virtual PString | GetNewFactoryName ()
OpalManager & | GetManager () const
| Get manager.

## Protected Member Functions

virtual PString | CreateInternalURI (const PGloballyUniqueID &guid)
virtual void | OnNodeStatusChanged (const OpalMixerNode &node, OpalConferenceState::ChangeType change)

## Protected Attributes

OpalMixerNodeInfo * | m_adHocNodeInfo
OpalMixerNodeInfo * | m_factoryNodeInfo
PMutex | m_infoMutex
PAtomicInteger | m_factoryIndex

## Detailed Description

Mixer EndPoint. This class represents an endpoint that mixes media. It can be used as the basis for a Multipoint Conferencing Unit.

## Constructor & Destructor Documentation

OpalMixerEndPoint::OpalMixerEndPoint | ( | OpalManager & | manager,
|  | const char * | prefix |
| ) |  |  |

Create a new endpoint.

Parameters:

  manager | Manager of all endpoints.
  prefix | Prefix for URL style address strings

OpalMixerEndPoint::~OpalMixerEndPoint | ( |  | ) |

Destroy endpoint.

## Member Function Documentation

virtual OpalMixerConnection* OpalMixerEndPoint::CreateConnection | ( | PSafePtr< OpalMixerNode > | node,
|  | OpalCall & | call,
|  | void * | userData,
|  | unsigned | options,
|  | OpalConnection::StringOptions * | stringOptions |
| ) |  |  | `[virtual]`

Create a connection for the PCSS endpoint. The default implementation is to create a OpalMixerConnection.

Parameters:

  node | Node the connection is in
  call | Owner of connection
  userData | Arbitrary data to pass to connection
  options | Option bit mask to pass to connection
  stringOptions | Options to pass to connection

virtual PString OpalMixerEndPoint::CreateInternalURI | ( | const PGloballyUniqueID & | guid | ) | `[protected, virtual]`

Internal function to get internal URI string.

Reimplemented from OpalMixerNodeManager.

virtual OpalMixerNodeInfo* OpalMixerEndPoint::FindNodeInfo | ( | const PString & | name | ) | `[virtual]`

Get Node Info for the given alias name. Default behaviour returns a clone of m_adHocNodeInfo.

virtual PBoolean OpalMixerEndPoint::GarbageCollection | ( |  | ) | `[virtual]`

Execute garbage collection for endpoint. Returns true if all garbage has been collected. Default behaviour deletes the objects in the connectionsActive list.

Reimplemented from OpalMixerNodeManager.

OpalMixerNodeInfo* OpalMixerEndPoint::GetAdHocNodeInfo | ( |  | ) | `[inline]`

Get default ad hoc mode information. The pointer returned from this function is passed to the CreateNode() function, so may be a reference to derived class, which a derived class of OpalMixerNode could use.

Note if NULL, then ad hoc nodes are not created and incoming connections are refused. A user must expicitly call AddNode() to create a name that can be connected to.

Default bahaviour returns member variable m_adHocNodeInfo.

virtual bool OpalMixerEndPoint::GetConferenceStates | ( | OpalConferenceStates & | states,
|  | const PString & | name = `PString::Empty()` |
| ) |  |  | const`[virtual]`

Get conference state information for all nodes. This obtains the state of one or more conferences managed by this endpoint. If this endpoint does not do conferencing, then false is returned.

The `name` parameter may be one of the aliases for the conference, or the internal URI for the conference. An empty string indicates all active conferences are to be returned.

Note that if the `name` does not match an active conference, true is still returned, but the states list will be empty.

The default behaviour returns false indicating this is not a conferencing endpoint.

Parameters:

  states | List of conference states
  name | Name for specific node, empty string is all

Reimplemented from OpalEndPoint.

OpalManager& OpalMixerEndPoint::GetManager | ( |  | ) | const`[inline]`

Get manager.

Reimplemented from OpalMixerNodeManager.

virtual OpalMediaFormatList OpalMixerEndPoint::GetMediaFormats | ( |  | ) | const`[virtual]`

Get the data formats this endpoint is capable of operating. This provides a list of media data format names that may be used by an OpalMediaStream may be created by a connection from this endpoint.

Note that a specific connection may not actually support all of the media formats returned here, but should return no more.

The default behaviour returns the most basic media formats, PCM audio and YUV420P video.

Reimplemented from OpalLocalEndPoint.

PSafePtr<OpalMixerConnection> OpalMixerEndPoint::GetMixerConnectionWithLock | ( | const PString & | token,
|  | PSafetyMode | mode = `PSafeReadWrite` |
| ) |  |  | `[inline]`

Find a connection that uses the specified token. This searches the endpoint for the connection that contains the token as provided by functions such as MakeConnection(). If not then it attempts to use the token as a OpalCall token and find a connection of the same class.

Parameters:

  token | Token to identify connection
  mode | Lock mode

virtual PString OpalMixerEndPoint::GetNewFactoryName | ( |  | ) | `[virtual]`

Generate a new name when a factory generated node is created. The default is to append a monitonic increasing integer to the factory name.

virtual PSafePtr<OpalConnection> OpalMixerEndPoint::MakeConnection | ( | OpalCall & | call,
|  | const PString & | party,
|  | void * | userData = `NULL`,
|  | unsigned | options = `0`,
|  | OpalConnection::StringOptions * | stringOptions = `NULL` |
| ) |  |  | `[virtual]`

Set up a connection to a remote party. This is called from the OpalManager::MakeConnection() function once it has determined that this is the endpoint for the protocol.

The general form for this party parameter is:

[proto:][alias@][transport$]address[:port]

where the various fields will have meanings specific to the endpoint type. For example, with H.323 it could be "h323:Fred@site.com" which indicates a user Fred at gatekeeper size.com. Whereas for the PSTN endpoint it could be "pstn:5551234" which is to call 5551234 on the first available PSTN line.

The proto field is optional when passed to a specific endpoint. If it is present, however, it must agree with the endpoints protocol name or false is returned.

This function usually returns almost immediately with the connection continuing to occur in a new background thread.

If false is returned then the connection could not be established. For example if a PSTN endpoint is used and the assiciated line is engaged then it may return immediately. Returning a non-NULL value does not mean that the connection will succeed, only that an attempt is being made.

Parameters:

  call | Owner of connection
  party | Remote party to call
  userData | Arbitrary data to pass to connection
  options | Option bit mask to pass to connection
  stringOptions | Options to pass to connection

virtual void OpalMixerEndPoint::OnNodeStatusChanged | ( | const OpalMixerNode & | node,
|  | OpalConferenceState::ChangeType | change |
| ) |  |  | `[protected, virtual]`

Call back when mixed node state information changes.

Default behaviour does nothing.

Reimplemented from OpalMixerNodeManager.

void OpalMixerEndPoint::SetAdHocNodeInfo | ( | OpalMixerNodeInfo * | info | ) |

void OpalMixerEndPoint::SetAdHocNodeInfo | ( | const OpalMixerNodeInfo & | info | ) |

Set default ad hoc node information. The pointer is passed to the CreateNode() function, so may be a reference to derived class, which a derived class of OpalMixerNode could use.

Note if NULL, then ad hoc nodes are not created and incoming connections are refused. A user must expicitly call AddNode() to create a name that can be connected to.

The version that takes a reference will utilise the Clone() function to create a copy of the mixer info.

void OpalMixerEndPoint::SetFactoryNodeInfo | ( | OpalMixerNodeInfo * | info | ) |

void OpalMixerEndPoint::SetFactoryNodeInfo | ( | const OpalMixerNodeInfo & | info | ) |

Set factory node information. If an incoming connections destination address is the info->m_name, then a new node is created and the incoming call is forwarded to it. This is an alternative to enabling ad-hoc nodes and follows the RFC4353 model.

The pointer is passed to the CreateNode() function, so may be a reference to derived class, which a derived class of OpalMixerNode could use.

Note if NULL, then factory nodes are not created and incoming connections are refused. A user must expicitly call AddNode() to create a name that can be connected to.

The version that takes a reference will utilise the Clone() function to create a copy of the mixer info.

virtual void OpalMixerEndPoint::ShutDown | ( |  | ) | `[virtual]`

Shut down the endpoint, this is called by the OpalManager just before destroying the object and can be handy to make sure some things are stopped before the vtable gets clobbered.

Reimplemented from OpalMixerNodeManager.

## Field Documentation

OpalMixerNodeInfo* OpalMixerEndPoint::m_adHocNodeInfo `[protected]`

PAtomicInteger OpalMixerEndPoint::m_factoryIndex `[protected]`

OpalMixerNodeInfo* OpalMixerEndPoint::m_factoryNodeInfo `[protected]`

PMutex OpalMixerEndPoint::m_infoMutex `[protected]`

The documentation for this class was generated from the following file:

- opalmixer.h